#ifndef BFM_VMX_H
#define BFM_VMX_H

extern "C" {

  //Linalg
 void vmx_vaxpy       (double*out,double *A,double *InScale, double *Add, integer len);
 void vmx_vaxpby      (double *out,double *A,double *B,double *InScale, double *Add, integer len);
 void vmx_vaxpy_norm  (double *out,double *A,double *InScale, double *Add, integer len, double *norm);
 void vmx_vaxpby_norm (double *out,double *A,double *B,double *InScale, double *Add, integer len, double *norm);
 void vmx_1pG5vaxpy   (double *addout,double *A,double *InScaleProj, integer len );


 void vmx_vaxpy_single       (float *out,double *A,float *InScale, float *Add, integer len);
 void vmx_vaxpby_single      (float *out,double *A,double *B,float *InScale, float *Add, integer len);
 void vmx_vaxpy_norm_single  (float *out,double *A,float *InScale, float *Add, integer len, double *norm);
 void vmx_vaxpby_norm_single (float *out,double *A,double *B,float *InScale, float *Add, integer len, double *norm);
 void vmx_1pG5vaxpy_single   (float *addout,double *A,float *InScaleProj, integer len );

  // comms suport
 void vmx_scatter(double *comm,
		   double *bagel,
		   integer nface, int cbLs);
 void vmx_scatter_single(float *comm,
			  float *bagel,
			  integer nface, int cbLs);

 void vmx_gather(integer *sites,
		 double  *bagel,
                 integer comm_off, 
		 double  *comm,
		 integer nface, int cbLs
                );
 void vmx_gather_single(integer *sites,
			float *bagel,
			integer comm_off, 
			float *comm,
			integer nface, int cbLs
			);

 void vmx_gather_permute(integer *sites,
			 integer comm_off, 
			 integer nface,
			 double *bagel,
			 int permute
			 );
 void vmx_gather_proj(integer arg_p);
 void vmx_gather_proj_single(integer arg_p);

  // Dirac ops
 void vmx_dwf(integer arg_p);
 void vmx_dwf_dag(integer arg_p);
 void vmx_dwf_addto(integer arg_p);
 void vmx_dwf_dag_addto(integer arg_p);
 void vmx_dperp(integer arg_p);
 void vmx_dperp_dag(integer arg_p);

 void vmx_dwf_single(integer arg_p);
 void vmx_dwf_dag_single(integer arg_p);
 void vmx_dwf_addto_single(integer arg_p);
 void vmx_dwf_dag_addto_single(integer arg_p);
 void vmx_dperp_single(integer arg_p);
 void vmx_dperp_dag_single(integer arg_p);

  /*Face scatter support for Bagel1*/
 void vmx_face_scatter(double *TwoSpinor,
		       double *RcvBuf, 
		       integer *FaceTable,
		       integer len);
 void vmx_face_scatter_single(float *TwoSpinor,
			      float *RcvBuf, 
			      integer *FaceTable,
			      integer len);
}
#endif 
