#ifndef _BFM_BAGEL1_H_
#define _BFM_BAGEL1_H_

template <class Float>
class bfmbagel1 : public bfmbase<Float> {

 public:

  // Adds fields that are specific to the Bagel2 implementation
  // of bfm
  Float *two_spinor[Ncb];
  integer *shift_table[Ncb];
  integer *face_table[Ncb][NMinusPlus][ND];

  Float *send_bufs[Ncb][NMinusPlus][ND];
  Float *recv_bufs[Ncb][NMinusPlus][ND];

  int PAD_HALF_SPINOR_SIZE;

  //////////////////////////////////////////////////////////////////////
  // Methods implemented here
  //////////////////////////////////////////////////////////////////////


#ifdef BFM_QDP_BINDING
  // Override the gauge import to match that for Bagel-1
  virtual void importGauge(multi1d<LatticeColorMatrix> &u);
#endif


  virtual int doubleStored(void) ;

  virtual void importGauge(QDPdouble *gauge, int dir) ;

  // Methods implemented here
  virtual void init(bfmarg &arg) ; 
  virtual void end (void) ;

  virtual integer bagel_idx   (int site[4],int reim,int i, int i_size,int half_cb) ;
  virtual integer bagel_idx5d (int site[4],int s,int reim,int i, int i_size,int half_cb);
  virtual integer bagel_idx5d (int site,int s,int i_size) ;

  virtual void dslash(Fermion_t chi, 
		      Fermion_t psi, 
		      int cb,
		      int dag,int dperp=1) ;


  virtual void Dperp(Fermion_t psi, 
		     Fermion_t chi, 
		     int cb,
		     int dag);

  virtual int simd(void) { return 1;};
  virtual void pointers_init(void) ;
  virtual void pointers_end(void) ; 

  void decom(Float *psi,Float *gauge,integer *len,integer *tab,int dag);
  void recon(Float *psi,Float *gauge,Float *chiin,integer *len,int dag);

  int  parity(int x[4]);
  int  psite (int x[4],int latt[4]);
  int  interleave_site(int pm,int mu, int site);

};

#endif
