/****************************************************************************/
/* PAB Jul 2007                                                             */
/****************************************************************************/

#include <stdlib.h>
#include <stdio.h>

#include "bfm.h"
#include "bfmcommfakebagel2.h"

template<class Float>
void commfakebagel2<Float>::comm_init (void){}
template<class Float>
void commfakebagel2<Float>::comm_end (void){}

// cb is cb of result, 1-cb is cb of input field, and it is this
// we communicate
template<class Float>
void commfakebagel2<Float>::comm_start(int result_cb, Fermion_t psi,int dag)
{
  comm(result_cb,psi,dag);
}
template<class Float>
void commfakebagel2<Float>::comm_complete(int result_cb, Fermion_t psi )
{
}
template<class Float>
void commfakebagel2<Float>::comm(int result_cb, Fermion_t psi, int dag)
{
  int nspinco = 12;
  int cb = 1-result_cb;

/**********************************************************
 * Gather the faces into the communications buffers
 **********************************************************
 *
 * Fake implementation - just gather the upper face directly 
 *                       into the (lower) receive buffer
 *
 * -> Gathers buffers at comm offset[pm][mu] from
 *    face_table[result_cb][pm][mu]
 **********************************************************
 */

  for(int mu=0;mu<ND;mu++){
  if ( (!this->local_comm[mu]) || (this->simd_grid[mu]>1) ) {

    int permute = 0;
    if ( this->simd_grid[mu] > 1 ) {
      permute = 1;
    }

    if ( this->simd_grid[mu] > 2 ) exit(0); // Not supported yet
    if ( this->simd()        > 2 ) exit(0); // Not supported yet

    int ftcb ;
    if ( this->precon_5d ) ftcb = 0;
    else ftcb = result_cb;
    for(int pm=0;pm<2;pm++){

      gather_face( this->face_table[ftcb][pm][mu], (Float *)psi,
	           this->comm_offset[pm][mu],
		   (Float *)psi,
                   this->simd_nbound[mu],
                   permute,this->cbLs);

    }
  }}

  // For comms just have to communicate this
}


template class commfakebagel2<float>;
template class commfakebagel2<double>;
